<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfDealPendingApprovalDetails ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfDealPendingApprovalDetails
 * @subpackage Arrays
 */
class ArrayOfDealPendingApprovalDetails extends AbstractStructArrayBase
{
    /**
     * The DealPendingApprovalDetails
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\DealPendingApprovalDetails[]
     */
    public $DealPendingApprovalDetails;
    /**
     * Constructor method for ArrayOfDealPendingApprovalDetails
     * @uses ArrayOfDealPendingApprovalDetails::setDealPendingApprovalDetails()
     * @param \StructType\DealPendingApprovalDetails[] $dealPendingApprovalDetails
     */
    public function __construct(array $dealPendingApprovalDetails = array())
    {
        $this
            ->setDealPendingApprovalDetails($dealPendingApprovalDetails);
    }
    /**
     * Get DealPendingApprovalDetails value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\DealPendingApprovalDetails[]|null
     */
    public function getDealPendingApprovalDetails()
    {
        return isset($this->DealPendingApprovalDetails) ? $this->DealPendingApprovalDetails : null;
    }
    /**
     * This method is responsible for validating the values passed to the setDealPendingApprovalDetails method
     * This method is willingly generated in order to preserve the one-line inline validation within the setDealPendingApprovalDetails method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateDealPendingApprovalDetailsForArrayConstraintsFromSetDealPendingApprovalDetails(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfDealPendingApprovalDetailsDealPendingApprovalDetailsItem) {
            // validation for constraint: itemType
            if (!$arrayOfDealPendingApprovalDetailsDealPendingApprovalDetailsItem instanceof \StructType\DealPendingApprovalDetails) {
                $invalidValues[] = is_object($arrayOfDealPendingApprovalDetailsDealPendingApprovalDetailsItem) ? get_class($arrayOfDealPendingApprovalDetailsDealPendingApprovalDetailsItem) : sprintf('%s(%s)', gettype($arrayOfDealPendingApprovalDetailsDealPendingApprovalDetailsItem), var_export($arrayOfDealPendingApprovalDetailsDealPendingApprovalDetailsItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The DealPendingApprovalDetails property can only contain items of type \StructType\DealPendingApprovalDetails, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set DealPendingApprovalDetails value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\DealPendingApprovalDetails[] $dealPendingApprovalDetails
     * @return \ArrayType\ArrayOfDealPendingApprovalDetails
     */
    public function setDealPendingApprovalDetails(array $dealPendingApprovalDetails = array())
    {
        // validation for constraint: array
        if ('' !== ($dealPendingApprovalDetailsArrayErrorMessage = self::validateDealPendingApprovalDetailsForArrayConstraintsFromSetDealPendingApprovalDetails($dealPendingApprovalDetails))) {
            throw new \InvalidArgumentException($dealPendingApprovalDetailsArrayErrorMessage, __LINE__);
        }
        if (is_null($dealPendingApprovalDetails) || (is_array($dealPendingApprovalDetails) && empty($dealPendingApprovalDetails))) {
            unset($this->DealPendingApprovalDetails);
        } else {
            $this->DealPendingApprovalDetails = $dealPendingApprovalDetails;
        }
        return $this;
    }
    /**
     * Add item to DealPendingApprovalDetails value
     * @throws \InvalidArgumentException
     * @param \StructType\DealPendingApprovalDetails $item
     * @return \ArrayType\ArrayOfDealPendingApprovalDetails
     */
    public function addToDealPendingApprovalDetails(\StructType\DealPendingApprovalDetails $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\DealPendingApprovalDetails) {
            throw new \InvalidArgumentException(sprintf('The DealPendingApprovalDetails property can only contain items of type \StructType\DealPendingApprovalDetails, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->DealPendingApprovalDetails[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\DealPendingApprovalDetails|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\DealPendingApprovalDetails|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\DealPendingApprovalDetails|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\DealPendingApprovalDetails|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\DealPendingApprovalDetails|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string DealPendingApprovalDetails
     */
    public function getAttributeName()
    {
        return 'DealPendingApprovalDetails';
    }
}
