<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfSubmitIncomingDealDetail ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfSubmitIncomingDealDetail
 * @subpackage Arrays
 */
class ArrayOfSubmitIncomingDealDetail extends AbstractStructArrayBase
{
    /**
     * The SubmitIncomingDealDetail
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\SubmitIncomingDealDetail[]
     */
    public $SubmitIncomingDealDetail;
    /**
     * Constructor method for ArrayOfSubmitIncomingDealDetail
     * @uses ArrayOfSubmitIncomingDealDetail::setSubmitIncomingDealDetail()
     * @param \StructType\SubmitIncomingDealDetail[] $submitIncomingDealDetail
     */
    public function __construct(array $submitIncomingDealDetail = array())
    {
        $this
            ->setSubmitIncomingDealDetail($submitIncomingDealDetail);
    }
    /**
     * Get SubmitIncomingDealDetail value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\SubmitIncomingDealDetail[]|null
     */
    public function getSubmitIncomingDealDetail()
    {
        return isset($this->SubmitIncomingDealDetail) ? $this->SubmitIncomingDealDetail : null;
    }
    /**
     * This method is responsible for validating the values passed to the setSubmitIncomingDealDetail method
     * This method is willingly generated in order to preserve the one-line inline validation within the setSubmitIncomingDealDetail method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateSubmitIncomingDealDetailForArrayConstraintsFromSetSubmitIncomingDealDetail(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfSubmitIncomingDealDetailSubmitIncomingDealDetailItem) {
            // validation for constraint: itemType
            if (!$arrayOfSubmitIncomingDealDetailSubmitIncomingDealDetailItem instanceof \StructType\SubmitIncomingDealDetail) {
                $invalidValues[] = is_object($arrayOfSubmitIncomingDealDetailSubmitIncomingDealDetailItem) ? get_class($arrayOfSubmitIncomingDealDetailSubmitIncomingDealDetailItem) : sprintf('%s(%s)', gettype($arrayOfSubmitIncomingDealDetailSubmitIncomingDealDetailItem), var_export($arrayOfSubmitIncomingDealDetailSubmitIncomingDealDetailItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The SubmitIncomingDealDetail property can only contain items of type \StructType\SubmitIncomingDealDetail, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set SubmitIncomingDealDetail value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\SubmitIncomingDealDetail[] $submitIncomingDealDetail
     * @return \ArrayType\ArrayOfSubmitIncomingDealDetail
     */
    public function setSubmitIncomingDealDetail(array $submitIncomingDealDetail = array())
    {
        // validation for constraint: array
        if ('' !== ($submitIncomingDealDetailArrayErrorMessage = self::validateSubmitIncomingDealDetailForArrayConstraintsFromSetSubmitIncomingDealDetail($submitIncomingDealDetail))) {
            throw new \InvalidArgumentException($submitIncomingDealDetailArrayErrorMessage, __LINE__);
        }
        if (is_null($submitIncomingDealDetail) || (is_array($submitIncomingDealDetail) && empty($submitIncomingDealDetail))) {
            unset($this->SubmitIncomingDealDetail);
        } else {
            $this->SubmitIncomingDealDetail = $submitIncomingDealDetail;
        }
        return $this;
    }
    /**
     * Add item to SubmitIncomingDealDetail value
     * @throws \InvalidArgumentException
     * @param \StructType\SubmitIncomingDealDetail $item
     * @return \ArrayType\ArrayOfSubmitIncomingDealDetail
     */
    public function addToSubmitIncomingDealDetail(\StructType\SubmitIncomingDealDetail $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\SubmitIncomingDealDetail) {
            throw new \InvalidArgumentException(sprintf('The SubmitIncomingDealDetail property can only contain items of type \StructType\SubmitIncomingDealDetail, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->SubmitIncomingDealDetail[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\SubmitIncomingDealDetail|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\SubmitIncomingDealDetail|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\SubmitIncomingDealDetail|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\SubmitIncomingDealDetail|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\SubmitIncomingDealDetail|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string SubmitIncomingDealDetail
     */
    public function getAttributeName()
    {
        return 'SubmitIncomingDealDetail';
    }
}
